#include "common.hpp"
#include "utils.hpp"

#include <vector>

#ifndef ENERGY_GRID_H_
#define ENERGY_GRID_H_

namespace docking{

  struct EnergyGrid{
    utils::Vec3D<fltype> center, pitch;
    utils::Vec3D<int> num;
    fltype* energy_list;
    bool is_valid;
  };

  EnergyGrid ReadEnergyGridFile(const char *filename);
  void WriteEnergyGridFile(const char *filename, const docking::EnergyGrid *grid);
  fltype GetValueNearest(const EnergyGrid *grid, const utils::Vec3D<fltype> *point);
  fltype GetValueTrilinear(const EnergyGrid *grid, const utils::Vec3D<fltype> *point);

  
}

#endif
