#include <string>
#include <map>

#include "common.hpp" // typedef fltype

#ifndef PARAM_AD_READER_H_
#define PARAM_AD_READER_H_
namespace docking{

struct HydrogenBond{
  enum TypeEnum{
    NONE                   = 0x00000001,
    DONOR_SPHERICAL        = 0x00000002,
    DONOR_DIRECTIVE        = 0x00000004,
    DONOR_ALL              = DONOR_SPHERICAL | DONOR_DIRECTIVE,
    ACCEPTOR_SPHERICAL     = 0x00000008,
    ACCEPTOR_DIRECTIVE_ONE = 0x00000010,
    ACCEPTOR_DIRECTIVE_TWO = 0x00000020,
    ACCEPTOR_ALL           = ACCEPTOR_SPHERICAL | ACCEPTOR_DIRECTIVE_ONE | ACCEPTOR_DIRECTIVE_TWO
  };
};

typedef struct AtomParamAD{
  int atomNumber;
  std::string atomType;
  fltype vdw_sigma;
  fltype vdw_epsilon;
  fltype vol;
  fltype solpar;
  fltype hb_sigma;
  fltype hb_epsilon;
  docking::HydrogenBond::TypeEnum hb_type;
} AtomParamAD;


std::map<std::string, AtomParamAD> GetAtomParamAD(const char* filename);
}//namespace docking

#endif
