#include "common.hpp"
#include <string>
#include <vector>


#ifndef PDBQT_READER_H_
#define PDBQT_READER_H_

namespace format{
using std::string;

struct PDBQTAtom {
  int id;
  string name;
  string element;
  fltype x, y, z;
  fltype charge;
  int residueID;
  char chainID;
  string residue_name;
};

struct PDBQTBond {
  int bond_id;
  int origin_atom_id, origin_atom_index;
  int target_atom_id, target_atom_index;
};

struct PDBQTMolecule {
  string title;
  string id_code;
  std::vector<PDBQTAtom> atoms;
  std::vector<PDBQTBond> bonds;
};

PDBQTMolecule ParsePDBQTFile(std::istream &pdbqt_stream);
PDBQTMolecule ParsePDBQTFile(const char *filename);
}

#endif //PDBQT_READER_H_
